namespace sGUI

declare function AddMenuGadget (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuItem (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuCheckMark (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuOpen (entry as sGUIEntry ptr) as Gadget ptr
declare function AddMenuSeparator (entry as sGUIEntry ptr) as Gadget ptr

declare function MIT_Actions(gad as Gadget ptr,action as integer) as integer
declare function MCM_Actions(gad as Gadget ptr,action as integer) as integer
declare function MOP_Actions(gad as Gadget ptr,action as integer) as integer
declare function MSP_Actions(gad as Gadget ptr,action as integer) as integer

declare sub MIT_Draw (gad as Gadget ptr)
declare sub MCM_Draw (gad as Gadget ptr)
declare sub MOP_Draw (gad as Gadget ptr)
declare sub MSP_Draw (gad as Gadget ptr)

declare sub MGT_Update(gad as Gadget ptr) 

declare sub CreatePopUpMenu(menulist as sGUIList ptr)
declare sub CreateMenuGadget (entry as sGUIEntry ptr)

declare sub OpenPopUpMenu(menulist as sGUIList ptr, PosX as integer, PosY as integer)
declare sub HideAllMenuWindows
declare sub LocateMenuWindow (win as sGUIWindow ptr, PosX as integer, PosY as integer)
declare sub OpenStripWindowPath (win as sGUIEntry ptr, PosX as integer, PosY as integer)

declare function FoundInList (list as sGUIList ptr, thing as any ptr) as integer
'siehe MCP.bas und nach end namespace am Ende dieser .bas
'dort erfolgt die "Zuweisung" dieser Sub ausserhalb des Namespaces als "ausfhrbarer Code"
declare sub MenuHandler(win as sGUIWindow ptr)

/'
type MNG_Data
	MenuEntry
  TimeStamp  
end type
'/

'**********************************************************
function AddMenuGadget (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  dim as sGUIWindow ptr win
  dim as node ptr node
  win=entry->StripWindow
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
    'Anhngen dieses Gadgets an eine "universelle" PointerListe speziell fr Meneintrage, dient der noch ungenutzen leichteren(?) Verarbeitung
    node=MenuGadgetList->AppendNew (NodeType) 
    node->anypointer=gad		
    
    gad->parent=win
    gad->Selection  =entry->Selection 
		gad->Activation =entry->Activation
		if gad->Activation<>1 then gad->Activation=2
    gad->PosX       =entry->PosX
		gad->PosY       =entry->PosY
		gad->GadWidth   =entry->EntryWidth
		gad->GadHeight  =entry->EntryHeight
		gad->Text       =entry->Text       
  
    gad->xtd.mng.MenuEntry  =entry
    entry->MenuGadget       =gad
    
    gad->DrawBuffer->img    =imagecreate(gad->GadWidth,Gad->GadHeight)
    
    'Timer gleichsetzen
    gad->xtd.mng.TimeStamp=timer
    gad->xtd.mng.MenuEntry->TimeStamp =  gad->xtd.mng.TimeStamp
    
    gad->DoUpdate           =@MGT_Update'eine Update-Routine fr alle MenGadgets
		function=gad
	end if
end function


sub MGT_Update(gad as Gadget ptr) 
  if gad->xtd.mng.TimeStamp <> gad->xtd.mng.MenuEntry->TimeStamp then'falls Daten im Gadget oder MenListenEintrag unerschiedlich alt sind 
  
    if gad->xtd.mng.TimeStamp > gad->xtd.mng.MenuEntry->TimeStamp then
      'Daten im Gadget sind aktueller, d.h EXPORT
      'Gadget --> Entry
      gad->xtd.mng.MenuEntry->TimeStamp = gad->xtd.mng.TimeStamp'Zeiten angleichen      
      gad->xtd.mng.MenuEntry->Selection = gad->Selection
      gad->xtd.mng.MenuEntry->Activation=iif(gad->Activation=1,1,0)

         
    else
      'Daten im Eintrag sind aktueller, d.h IMPORT  
      'Entry --> Gadget
      gad->xtd.mng.TimeStamp  = gad->xtd.mng.MenuEntry->TimeStamp'Zeiten angleichen   
      gad->Selection          = gad->xtd.mng.MenuEntry->Selection
      gad->Activation         = iif(gad->xtd.mng.MenuEntry->Activation=1,1,2)    
      gad->ReDraw=1    
    end if   
  end if
end sub


'**********************************************************


function AddMenuItem (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MIT_Draw
    gad->DoAction           =@MIT_Actions
    function=gad
  end if
end function


function MIT_Actions(gad as Gadget ptr,action as integer) as integer
  'dim as sGUIEntry entry
  'entry=gad->xtd.mng.MenuEntry
  function=0
  select case action
    case GADGET_LMBRELEASE
      SetSelect (gad,0)  
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index   
      function=1
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MIT_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY
  dim as FB.Image ptr buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =GetFontHeight(2) + 2*LeastGap 
	TextPosY    =int((GadHeight-GetFontHeight(2))/2)
  
  Buffer   =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)
    end if
	end if
end sub


'**********************************************************


function AddMenuSeparator (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
		gad->DoDraw             =@MSP_Draw
		gad->DoAction           =@MSP_Actions
    function=gad
  end if  
end function


sub MSP_Draw (gad as Gadget ptr)
  dim as integer GadWidth,GadHeight,BarPosX,BarPosY,BarWidth,BarHeight
  dim as FB.Image ptr buffer
  
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  BarWidth    =GadWidth/3' - 4*MainWidth
  BarHeight   =1
  BarPosX     =(GadWidth-BarWidth)/2
  BarPosY     =(GadHeight-BarHeight)/2
  Buffer   =gad->DrawBuffer->img	
    
	ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
  
  ClearBox Buffer,BarPosX,BarPosY,BarWidth,BarHeight,Colors.MNG_TextInactive
  
end sub

function MSP_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
end function


'**********************************************************


function AddMenuCheckMark (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MCM_Draw
    gad->DoAction           =@MCM_Actions
    function=gad
  end if
end function


function MCM_Actions(gad as Gadget ptr,action as integer) as integer
  'dim as sGUIEntry entry
  'entry=gad->xtd.mng.MenuEntry
  function=0
  select case action
    case GADGET_LMBRELEASE
      SetSelect(gad,iif(GetSelect(gad),0,1))
      gad->xtd.mng.TimeStamp=timer
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index       
      function=1      
    
    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MCM_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY,SymbolSize,SymbolPosY
  dim as FB.Image ptr buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =GetFontHeight(2) + 2*LeastGap 
	TextPosY    =int((GadHeight-GetFontHeight(2))/2)
  SymbolSize  =GetFontHeight(2)*.66
  SymbolPosY  =int((GadHeight-SymbolSize)/2)
  Buffer   =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
      if gad->Selection then Symbol_CheckMark (Buffer,LeastGap,SymbolPosY,SymbolSize,Colors.MNG_HoverFXText)
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)
      if gad->Selection then Symbol_CheckMark (Buffer,LeastGap,SymbolPosY,SymbolSize,Colors.MNG_Text)      
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)
      if gad->Selection then Symbol_CheckMark (Buffer,LeastGap,SymbolPosY,SymbolSize,Colors.MNG_TextInactive)      
    end if
	end if
end sub


'**********************************************************


function AddMenuOpen (entry as sGUIEntry ptr) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
  gad=AddMenuGadget (entry)
  if gad then
    gad->DoDraw             =@MOP_Draw
    gad->DoAction           =@MOP_Actions
    function=gad
  end if
end function


function MOP_Actions(gad as Gadget ptr,action as integer) as integer
  'dim as sGUIEntry entry
  'entry=gad->xtd.mng.MenuEntry
  function=0
  select case action
    case GADGET_LMBRELEASE
      SetSelect (gad,0)  
      MENUBASE=gad->xtd.mng.MenuEntry->Owner
      MENUID=gad->xtd.mng.MenuEntry->Index      
      function=1

    case GADGET_MOUSEHOVER   'Mouse berm Control
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
      gad->MouseHover=0       
  end select
end function


sub MOP_Draw (gad as Gadget ptr)
  dim as integer GadPosX,GadPosY,GadWidth,GadHeight,TextPosX,TextPosY,SymbolSize,SymbolPosX,SymbolPosY
  dim as FB.Image ptr buffer
  
  GadPosX     =gad->PosX
  GadPosY     =gad->PosY
  GadWidth    =gad->GadWidth
	GadHeight   =gad->GadHeight
  TextPosX    =GetFontHeight(2) + 2*LeastGap 
	TextPosY    =int((GadHeight-GetFontHeight(2))/2)
  SymbolSize  =GetFontHeight(2)*.66
  SymbolPosX  =GadWidth - LeastGap - SymbolSize
  SymbolPosY  =int((GadHeight-SymbolSize)/2)
  Buffer   =gad->DrawBuffer->img	
    
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight
  'ON   unselect/select
  if gad->Activation then
		if gad->MouseHover then
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_HoverFX
      drawstring (Buffer, TextPosX, TextPosY, gad->Text,Colors.MNG_HoverFXText,2)
      Symbol_Arrow (Buffer,SymbolPosX,SymbolPosY,SymbolSize,1,Colors.MNG_HoverFXText)
    else
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround    
			drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_Text,2)
      Symbol_Arrow (Buffer,SymbolPosX,SymbolPosY,SymbolSize,1,Colors.MNG_Text)      
    end if
		'SLEEP
		if gad->Activation=2 then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.MNG_BackGround
      drawstring (Buffer, TextPosX, TextPosY, gad->Text, Colors.MNG_TextInactive,2)
      Symbol_Arrow (Buffer,SymbolPosX,SymbolPosY,SymbolSize,1,Colors.MNG_TextInactive)      
    end if
	end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************


sub CreatePopUpMenu(menulist as sGUIList ptr)
  dim as sGUIEntry ptr entry,e,prev
  dim as sGUIWindow ptr SWin
  dim as node ptr node
  dim as integer group,up,SWWidth,SWHeight
  
  if MenuValidator(menulist,1) then
  
    MenuSetLevel(menulist)
    MenuSetGroup(menulist)
    
    entry=menulist->GetFirst  
    group=0  
  
    if entry then
      '!!! immer der erste Eintrag einer MenuBase enthlt im ->Qualifier
      'die "Art der Nutzung" der Base als Men
      '0=Window PullDown 
      '1=PopUp
      entry->Qualifier=1
      do
        up=0
        e=entry
        SWWidth=0
        SWHeight=0
        
        '1. breitesten Eintrag der Gruppe finden, Position im StripWindow definieren, Hhe frs StripWindow finden
        do
          if e->MemberOfGroup>group then up=1
          
          if e->MemberOfGroup=group then
            if e->EntryWidth>SWWidth then SWWidth=e->EntryWidth
            e->PosX=0
            e->PosY=SWHeight'SWHeight=auflaufende StripHhe
            SWHeight +=e->EntryHeight
          end if
                 
          e=cast(sGUIEntry ptr,e->next_node)'nchsten Eintrag holen       
        loop until e=0
        SWWidth +=2*GetFontHeight(2) + 4*LeastGap 'zustzl. Platz frs Checkmark und Submen-Arrow
        
        '2. StripWindow erzeugen
        SWin=AddWindow(0,10,10,SWWidth,SWHeight,,WFLAG_ALWAYSONTOP)
          'Anhngen dieses Fensters an eine "universelle" PointerListe speziell fr MenFenster, dient der noch ungenutzen leichteren(?) Verarbeitung
          node=MenuWindowList->AppendNew (NodeType) 
          node->anypointer=SWin	        
        'ShowWindow SWin
        
        '3. alle Eintrtrge an die Breite ihrer Gruppe anpassen, StripFenster allen Eintrgen der Gruppe zuweisen 
        e=entry
        do
          
          if (e->MemberOfGroup=group) then ' and (e->EntryType<>ETYPE_CLOSEMENUSTRIP) then
            
            'if group=0 then
          
            'else
              e->EntryWidth=SWWidth'bei allen anderen Gruppen Breite anpassen          
            'end if
            e->StripWindow=SWin
          end if
                 
          e=cast(sGUIEntry ptr,e->next_node)'nchsten Eintrag holen       
        loop until e=0 
        
        if up=1 then group +=1  
      loop until up=0
      
      '4. jedem OpenStrip dessen ChildStrip zuweisen
      e=entry
      prev=0
      do
        CreateMenuGadget(e)
        if prev<>0 then
          if prev->EntryType=ETYPE_OPENMENUSTRIP then
            prev->ChildStripWindow=e->StripWindow
          end if
        end if
        prev=e       
        e=cast(sGUIEntry ptr,e->next_node)'nchsten Eintrag holen       
      loop until e=0
      
    end if  
  end if  
end sub


sub CreateMenuGadget (entry as sGUIEntry ptr)
  dim as Gadget ptr gad
  select case entry->EntryType
    case ETYPE_ITEM
      gad=AddMenuItem (entry)
    
    case ETYPE_SEPARATOR
      gad=AddMenuSeparator (entry)      
    
    case ETYPE_CHECKMARK
      gad=AddMenuCheckMark (entry)
      
    case ETYPE_OPENMENUSTRIP
     gad=AddMenuOpen (entry)     
      
  end select
  'if gad then GadgetOn(gad)
end sub


sub OpenPopUpMenu(menulist as sGUIList ptr, PosX as integer, PosY as integer)
  dim as sGUIEntry ptr entry,e
  dim as sGUIWindow ptr basewin
  entry=menulist->GetFirst
  
  if entry then
    basewin=entry->StripWindow
    
    'alle StripWindows schliessen
    HideAllMenuWindows
    
    '"BaseWindow" positionieren
    LocateMenuWindow (basewin, PosX, PosY)
    
    '"BaseWindow" ffnen
    ShowWindow(basewin)
    MENUBASE=menulist
    MENUOPEN=1
  end if  
end sub


sub HideAllMenuWindows
  dim as node ptr node
  node=MenuWindowList->GetFirst
  if node then
    do
      HideWindow(cast (sGUIWindow ptr,node->anypointer))
      node=node->next_node
    loop until (node=0)
  end if
  MENUOPEN=0
end sub


sub LocateMenuWindow (win as sGUIWindow ptr, PosX as integer, PosY as integer)
  if (PosX + win->WinWidth) > ScrnWidth then PosX = ScrnWidth - win->WinWidth
  if PosX < 0 then PosX = 0
  if (PosY + win->WinHeight) > ScrnHeight then PosY = ScrnHeight - win->WinHeight
  if PosY < 0 then PosY = 0 
  win->PosX=PosX
  win->PosY=PosY
end sub


sub OpenStripWindowPath (entry as sGUIEntry ptr, PosX as integer, PosY as integer)
  dim as integer lvl,q
  dim as sGUIList ptr mbase
  dim as sGUIEntry ptr first
  dim as sGUIWindow ptr topwindow
  mbase=entry->Owner
  first=mbase->GetFirst
  q=first->Qualifier
  topwindow=0
  if entry then
    HideAllMenuWindows
    LocateMenuWindow (entry->ChildStripWindow, PosX, PosY)  
    if q then ShowWindow(first->StripWindow) 
    do
      if entry->EntryType=ETYPE_OPENMENUSTRIP then     
        'if topwindow=0 then topwindow=entry->ChildStripWindow
        'MoveWindowOnTop (entry->ChildStripWindow)
        ShowWindow(entry->ChildStripWindow)    
        lvl=entry->Level
      end if
      entry=cast(sGUIEntry ptr,entry->prev_node)'vorhergehenden Eintrag holen       
    loop until (entry=0) or (lvl=0)
  end if
  'MoveWindowOnTop (topwindow)
  MENUOPEN=1
end sub


function FoundInList (list as sGUIList ptr, thing as any ptr) as integer
  dim as integer found
  dim as node ptr n
  found=0
  n=list->GetFirst
  if n then
    do
      if n->anypointer=thing then found=1
      n=n->next_node
    loop until (n=0) or (found=1) 
  end if
  function=found
end function


sub MenuHandler(win as sGUIWindow ptr)
  dim as sGUIEntry ptr entry
  dim as integer gadx,gady

  if FoundInList (MenuWindowList,win) then
    if GADGETMESSAGE then
      entry=GADGETMESSAGE->xtd.mng.MenuEntry
      GetGlobalPosition(GADGETMESSAGE,gadx,gady)             
      select case entry->EntryType
        case ETYPE_OPENMENUSTRIP
          OpenStripWindowPath (entry, gadx + GADGETMESSAGE->GadWidth, gady)
          MENUBASE=0
          MENUID=0
        case ETYPE_ITEM,ETYPE_CHECKMARK
          HideAllMenuWindows
      end select

      WINDOWMESSAGE=0
      GADGETMESSAGE=0    
    end if
  else
    if MENUOPEN then HideAllMenuWindows     
  end if  
end sub

end namespace
'******************************************************************************
'... und nun der ausfhrbare Code, diese Datei ist ja schliesslich keine *.bi ;P
sGUI.MenuHandlerCall=@sGUI.MenuHandler()
'******************************************************************************
